{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.astroVscode = {
          enable = lib.mkEnableOption "should the astro-vscode extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "astro-vscode" {
            default = ["astro-build" "astro-vscode"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.astroVscode.enable {
        extensions = [
          config.extraExtensions.astroVscode.extension
        ];
      };
    }));
  };
}
