{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.vscodeMdx = {
          enable = lib.mkEnableOption "should the vscode-mdx extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "vscode-mdx" {
            default = ["unifiedjs" "vscode-mdx"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.vscodeMdx.enable {
        extensions = [
          config.extraExtensions.vscodeMdx.extension
        ];
      };
    }));
  };
}
